// Allison Traylor
// atraylor@andrew.cmu.edu
//Final project

//This code makes the ball scene

//Physics
var px = 10; // starting ball location x
var py = 200; // starting ball location y
var pxv = 2; // velocity in x
var pyv = 1; // velocity in y
var pyf = 0.2; // gravity
var damping = 0.7; // so ball looses height on each bounce
                    //(partially inelastic collisions)
var drag = 0.001; //air drag
var diam = 20; // ball diameter
var ballCount = 0; // counting frames for displaying text
function setup(){
    createCanvas(600, 600);
}

function makeBall(){
    background(220);
    fill(200, 0, 0);
    noStroke();
    ellipse(px, py, diam, diam); // ball
    px += pxv; // velocity x
    py += pyv; // velocity y

    pyv += pyf; //accel y aka gravity

    pyv -= pyv * pyv * drag; // adding drag
    if (py > height){ //if the ball hits the ground
        py = height - diam/2; // put the ball at the ground
        pyv = - pyv * damping; // change its velocity y to the opposite
                            //direction and reduce speed
        ballBounce.amp(0.5); // lower volume of ball spring sound
        ballBounce.play(); // play ball bounce sound on hit
    }

    if (ballCount > 170){ //after 120 frames in the scene, text will be displayed
        textSize(15);
        text("i'm bored.", (width/3 + 64), (3 * height/4 + 10));
    } else{
        textSize(20);
        textFont("Arial");
        text("press a key to have fun!", (width/3 + 64), (3 * height/4 + 10));
    }
    ballCount += 1; // count the frames

}

function keyPressed(){ // pressing a key will move ball to mouse location
    if (clickBall == 1){ // can only be done in the ball scene
        if (clickPainting == 0 && clickWindow == 0 && clickBook == 0){ // can
                                //only be done while all other scenes are off
            px = mouseX; // place ball at mouse location
            py = mouseY;
            ballSound.amp(0.2); //throw sound volume
            ballSound.rate(2); // speed it up
            ballSound.play(); // play throw sound when key is pressed
        }
    }
}
