// Allison Traylor
// atraylor@andrew.cmu.edu
//Final project

//This code makes the window scene

var rain = []; // array to hold the rain objects
var rainCount = 0; // counting frames of this specific scene.

function setup() {
    createCanvas(600, 600);
    for (var i = 0; i < 10; i++){
        var rx = random(width);
        var ry = random(height);
        rain[i] = makerain(rx, ry); //populate screen
    }
}

function makeRain(){
    background(200);
    fill(190); //horizon
    noStroke();
    rect(0, height/2 + 80, width, 500); //horizon
    noStroke();
    fill(100);
    if (rainCount > 130){ // after 130 frames in the scene, text will be displayed
            text("i'm bored.", width/4 - 30, height/4 - 30);
    }
    rainCount += 1; // counting frames in this scene

    makeTrees(); //trees
    updateAndDisplayrain(); //rain
    addRanProbrain();
    rainDeath();
}

function updateAndDisplayrain(){
    for (var i = 0; i < rain.length; i++){ //draw and update rain
        rain[i].move();
        rain[i].draw();
    }
}

function rainDeath(){ //kill raindrops that go off screen
    var liverain = [];
    for (var i = 0; i < rain.length; i++){
        if (rain[i].y < height){
            liverain.push(rain[i]);
        }
    }
    rain = liverain; //remember live rain drops
}

function addRanProbrain(){ //make more of the rain appear
    var prob = 0.95; // this will change the amount of rain
    if (random(0,1) < prob){
        rain.push(makerain(random(width), 0));
        var rainSoundProb = 0.05;
        if (random(0, 1) < rainSoundProb){
            dropSound.play();
        }
    }
}

function rainMove(){ // make the rain fall
    this.y += this.speed;
}

function rainDraw(){ // making the rain shape
    strokeWeight(1);
    stroke(0);
    line(this.x, this.y, this.x, this.y + 10);
}

function makerain(birthlocationx, birthlocationy){
    var rain = {'x': birthlocationx,
        'y': birthlocationy,
        'rainCol': pickColor(),
        'speed': pickSpeed(),
        'csize':(-1 * pickSpeed() * 2),
        'move': rainMove,
        'draw': rainDraw}

    return rain;
}

function pickColor(){
    return int(random(100, 255));
}

function pickSpeed(){
    return random(10, 20);
}

/* Things below are for drawing the fractal trees.
*/

var offset; // offset for wind in branches

function setup() {
    createCanvas(600, 600);
}

function makeTrees() {
    // trees
    stroke(0);
    push();
    strokeWeight(1.2);
    translate(width / 2 - 90, height / 2 + 100);
    drawBranch(0, 30);
    pop();

    push();
    strokeWeight(1.5);
    translate(width / 2 - 140, height / 2 + 120);
    drawBranch(0, 35);
    pop();

    push();
    strokeWeight(1.5);
    translate(width / 2 + 140, height / 2 + 120);
    drawBranch(0, 35);
    pop();

    push();
    strokeWeight(.85);
    translate(width / 2 + 110, height / 2 + 100);
    drawBranch(0, 27);
    pop();

    push();
    strokeWeight(.5);
    translate(width/2 + 70, height/2 + 90);
    drawBranch(0, 20);
    pop();

    push();
    strokeWeight(.4);
    translate(width / 2 - 65, height / 2 + 80);
    drawBranch(0, 15);
    pop();
}

function drawBranch(depth, len) { // set up the segment of the tree
    line(0, 0, 0, -len);
    push();
    translate(0, -len);
    drawTree(depth + 1, len);
    pop();
}

function drawTree(depth, len) { // making the trees with the branches and wind offset
    var rotA = 20; // values for angle changes for branches
    var rotB = -10;
    var rotC = 8;

    var oAngle = 45; // angle for offset
    var treeProb = 0.5;
    if (random(0,1) < treeProb){
        var offset = sin(radians(oAngle)) * 1.5;
   }
    if (depth < 7){ // there will be seven iterations
        if (depth > 1){ // I'm defining characteristics at the levels
            rotA = 30;
            rotB = -20;
        }
        if (depth > 4){
            strokeWeight(.6)
            rotate(radians(offset * .5));
            rotate(radians(rotC)); //add a third branch
            drawBranch(depth, len);
            rotA = 40;
            rotB = -20;
        }
        if (depth > 6){
            roate(radians(offset)); //offset is greatest at outermost branches
            strokeWeight(.3);
        }
        rotate(radians(offset * .3));
        rotate(radians(rotB));
        drawBranch(depth, len);
        rotate(radians(rotA));
        drawBranch(depth, len);
    }
    oAngle += 2;
}
