// Allison Traylor
// atraylor@andrew.cmu.edu
//Final project

//This code makes the room

var windowImage; // vaiables for the loaded images
var bookImage;
var paintingImage;
var backgroundImage;
var titleBanner;
var ballmove; //value to move ball with

var leftX = 130, rightX = 300; //these are the starting locations for the "flies"
var leftY = 300, rightY = 100;

function preload(){
    windowImage = loadImage("https://i.imgur.com/YuzE6He.png");
    bookImage = loadImage("https://i.imgur.com/QOKNF3W.png");
    paintingImage = loadImage("https://i.imgur.com/cO40p8o.png");
    backgroundImage = loadImage("https://i.imgur.com/Gjnij04.jpg");
    titleBanner = loadImage("https://i.imgur.com/6ZQeAIl.png");
    ocean = loadSound("water.wav");
    dropSound = loadSound("drop.wav");
    ballBounce = loadSound("spring.wav");
    bookSound = loadSound("page.wav");
    ballSound = loadSound("woosh.wav");
    flySound = loadSound("flies.wav");
    moreOcean = loadSound("morewater.wav");
}

function makeRoom(){
    noStroke();
    fill(220);
    rect(0, 3 * height / 4, width, 100); // "table"
    fill(190);
    rect(0, 3 * height / 4 + 80, width, 40); // more table
    ballmove = sin(millis() / 200) * 40; // rocking motion for the ball on the table
    fill(200, 0, 0);
    ellipse(width / 3 + 64 + ballmove / 4, 3 * height / 4 + 10, 70, 70); //"ball"
    noTint();
    image(windowImage, width / 4 - 50, height / 4 - 50); //window
    image(bookImage, 2 * width / 3, 3 * height / 4 + 10); //book
    image(paintingImage, width / 2 + 180, height / 4); //painting

    image(titleBanner, (width / 2) - 150, 10, 300, 128); //banner


    var flyoffset = sin(millis() / 200) * 50; //move the fly around the room
    fly(leftX + flyoffset, leftY + (flyoffset / 5));
    fly(rightX - flyoffset * 2, rightY);
    leftX += random(-5, 5); // buzzing motions of the flies
    leftY += random(-5, 5);
    rightX += random(-5, 5);
    rightY += random(-5, 5);

    var flySoundProb = 0.005;
    if (random(0, 1) < flySoundProb){
        if (clickPainting == 0 && clickBall == 0 && clickBook == 0 && clickWindow == 0){
            flySound.amp(0.8); // reduce fly noises
            flySound.play(); // play fly noises
        } else {
            flySound.stop(); // stop if in another scene
        }
    }

    textSize(10);
    fill(230);
    text("Click to entertain yourself, click again to come back. Also, there's sound, so if you want to have even more fun, turn up the volume.", 10, 590);
}

function fly(x, y) { // make the flies!
    noStroke();
    fill(0);
    ellipse(x, y, 5, 5);
}
